package com.listener;

import java.util.concurrent.atomic.AtomicInteger;

import org.testng.IInvokedMethod;
import org.testng.IInvokedMethodListener;
import org.testng.IInvokedMethodListener2;
import org.testng.IRetryAnalyzer;
import org.testng.ITestContext;
import org.testng.ITestResult;
import org.testng.util.RetryAnalyzerCount;

public class MyRetry implements IRetryAnalyzer,IInvokedMethodListener{


	AtomicInteger count = new AtomicInteger(2);

	protected void setCount(int count) {
		this.count.set(count);
	}

	/**
	 * Retries the test if count is not 0.
	 * 
	 * @param result
	 *            The result of the test.
	 */
	public boolean retry(ITestResult result) {
		boolean retry = false;

		if (count.intValue() > 1) {
			retry = true;
			count.decrementAndGet();
		}
		return retry;
	}

	public void afterInvocation(IInvokedMethod mt, ITestResult result) {
		
		int iCount = mt.getTestMethod().getCurrentInvocationCount();
		
//			if(!result.isSuccess() && iCount < count.get() )
//				result.setStatus(3);
			
	}

	public void beforeInvocation(IInvokedMethod arg0, ITestResult result) {
	}



}
